/*
 Project coded by 'The Real Nathanael'.
 This is completely open source and the user is free to edit as desired.
 Components needed: SR04 Ultrasonic sensor, 9g Servo motor, Solderless Wires (Male-Male x5) (Male - Female x4), 9V Battery and Connector.
 Libraries needed: HC-SR04, Servo. (Both should be in the same file as this code)
 */
#include "SR04.h" //The US sensor's library.
#include <Servo.h> //The servo's library.
#define TRIG_PIN 12 //The port for the US TRIG_PIN.
#define ECHO_PIN 11 //The Port for the US ECHO_PIN.
SR04 sr04 = SR04(ECHO_PIN,TRIG_PIN); //Creates a US sensor object.
Servo myservo; //Creates a servo object.

long a; //Holds the distance from the US sensor to the nearest object.
int pos = 0; //Holds the angle of the servo's arm.

void setup() {
  myservo.attach(9); //Tells the program that the servo is at port number 9
}

void loop() {
  a=sr04.Distance(); //Gets the distance to the nearest object.
  myservo.write(pos); //Sets the default position for the servo's arm.
  
  if(a < 8){ //This tells the program to only execute this statement if there is an object closer than 8 cm from the US sensor.
    
    pos = 90;
    myservo.write(pos); //These two lines move the arm to the 90 degree position, closing the claw.

    delay(2000); //Holds the claw closed for 2 seconds.
    
    for (pos = 90; pos >= 0; pos -= 1) { //This for loop opens the servo at a slower rate to which it closed.
      myservo.write(pos); //Opens the servo by 1 degree
      delay(15); //Allows some time for the previous command to be executed.
    }
  }
  
  delay(500); //Waits half a second before checking the distance again.
}
